// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes Windows Configuration of the OS Profile.
    /// </summary>
    public partial class LinuxConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the LinuxConfiguration class.
        /// </summary>
        public LinuxConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the LinuxConfiguration class.
        /// </summary>
        /// <param name="disablePasswordAuthentication">whether Authentication
        /// using user name and password is allowed or not</param>
        /// <param name="ssh">the SSH configuration for linux VMs</param>
        public LinuxConfiguration(bool? disablePasswordAuthentication = default(bool?), SshConfiguration ssh = default(SshConfiguration))
        {
            DisablePasswordAuthentication = disablePasswordAuthentication;
            Ssh = ssh;
        }

        /// <summary>
        /// Gets or sets whether Authentication using user name and password
        /// is allowed or not
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "disablePasswordAuthentication")]
        public bool? DisablePasswordAuthentication { get; set; }

        /// <summary>
        /// Gets or sets the SSH configuration for linux VMs
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "ssh")]
        public SshConfiguration Ssh { get; set; }

    }
}
