// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// SSH configuration for Linux based VMs running on Azure
    /// </summary>
    public partial class SshConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the SshConfiguration class.
        /// </summary>
        public SshConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the SshConfiguration class.
        /// </summary>
        /// <param name="publicKeys">the list of SSH public keys used to
        /// authenticate with linux based VMs</param>
        public SshConfiguration(System.Collections.Generic.IList<SshPublicKey> publicKeys = default(System.Collections.Generic.IList<SshPublicKey>))
        {
            PublicKeys = publicKeys;
        }

        /// <summary>
        /// Gets or sets the list of SSH public keys used to authenticate with
        /// linux based VMs
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "publicKeys")]
        public System.Collections.Generic.IList<SshPublicKey> PublicKeys { get; set; }

    }
}
