// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// The instance view of the VM Agent running on the virtual machine.
    /// </summary>
    public partial class VirtualMachineAgentInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineAgentInstanceView
        /// class.
        /// </summary>
        public VirtualMachineAgentInstanceView() { }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineAgentInstanceView
        /// class.
        /// </summary>
        /// <param name="vmAgentVersion">the VM Agent full version.</param>
        /// <param name="extensionHandlers">the virtual machine extension
        /// handler instance view.</param>
        /// <param name="statuses">the resource status information.</param>
        public VirtualMachineAgentInstanceView(string vmAgentVersion = default(string), System.Collections.Generic.IList<VirtualMachineExtensionHandlerInstanceView> extensionHandlers = default(System.Collections.Generic.IList<VirtualMachineExtensionHandlerInstanceView>), System.Collections.Generic.IList<InstanceViewStatus> statuses = default(System.Collections.Generic.IList<InstanceViewStatus>))
        {
            VmAgentVersion = vmAgentVersion;
            ExtensionHandlers = extensionHandlers;
            Statuses = statuses;
        }

        /// <summary>
        /// Gets or sets the VM Agent full version.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "vmAgentVersion")]
        public string VmAgentVersion { get; set; }

        /// <summary>
        /// Gets or sets the virtual machine extension handler instance view.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "extensionHandlers")]
        public System.Collections.Generic.IList<VirtualMachineExtensionHandlerInstanceView> ExtensionHandlers { get; set; }

        /// <summary>
        /// Gets or sets the resource status information.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "statuses")]
        public System.Collections.Generic.IList<InstanceViewStatus> Statuses { get; set; }

    }
}
