// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Deployment operation properties.
    /// </summary>
    public partial class DeploymentOperationProperties
    {
        /// <summary>
        /// Initializes a new instance of the DeploymentOperationProperties
        /// class.
        /// </summary>
        public DeploymentOperationProperties() { }

        /// <summary>
        /// Initializes a new instance of the DeploymentOperationProperties
        /// class.
        /// </summary>
        /// <param name="provisioningState">The state of the
        /// provisioning.</param>
        /// <param name="timestamp">The date and time of the operation.</param>
        /// <param name="serviceRequestId">Deployment operation service
        /// request id.</param>
        /// <param name="statusCode">Operation status code.</param>
        /// <param name="statusMessage">Operation status message.</param>
        /// <param name="targetResource">The target resource.</param>
        /// <param name="request">The HTTP request message.</param>
        /// <param name="response">The HTTP response message.</param>
        public DeploymentOperationProperties(string provisioningState = default(string), System.DateTime? timestamp = default(System.DateTime?), string serviceRequestId = default(string), string statusCode = default(string), object statusMessage = default(object), TargetResource targetResource = default(TargetResource), HttpMessage request = default(HttpMessage), HttpMessage response = default(HttpMessage))
        {
            ProvisioningState = provisioningState;
            Timestamp = timestamp;
            ServiceRequestId = serviceRequestId;
            StatusCode = statusCode;
            StatusMessage = statusMessage;
            TargetResource = targetResource;
            Request = request;
            Response = response;
        }

        /// <summary>
        /// Gets or sets the state of the provisioning.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets the date and time of the operation.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "timestamp")]
        public System.DateTime? Timestamp { get; set; }

        /// <summary>
        /// Gets or sets deployment operation service request id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "serviceRequestId")]
        public string ServiceRequestId { get; set; }

        /// <summary>
        /// Gets or sets operation status code.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "statusCode")]
        public string StatusCode { get; set; }

        /// <summary>
        /// Gets or sets operation status message.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "statusMessage")]
        public object StatusMessage { get; set; }

        /// <summary>
        /// Gets or sets the target resource.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "targetResource")]
        public TargetResource TargetResource { get; set; }

        /// <summary>
        /// Gets or sets the HTTP request message.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "request")]
        public HttpMessage Request { get; set; }

        /// <summary>
        /// Gets or sets the HTTP response message.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "response")]
        public HttpMessage Response { get; set; }

    }
}
